#!/usr/local/bin/php
<?php
/**
 * $Horde: mnemo/scripts/upgrades/2004-05-19_convert_categories_to_strings.php,v 1.3 2005/01/03 14:35:19 jan Exp $
 *
 * Copyright 2004-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('AUTH_HANDLER', true);
@define('MNEMO_BASE', dirname(__FILE__) . '/../..');
require_once MNEMO_BASE . '/lib/base.php';

// Run through every notepad.
$notepads = $mnemo_shares->listAllShares();
foreach ($notepads as $notepad => $share) {
    echo "Converting categories for $notepad ...\n";

    $categories = listCategories($notepad);

    // List all memos.
    $storage = &Mnemo_Driver::singleton($notepad);
    $storage->retrieve();
    $memos = $storage->listMemos();

    foreach ($memos as $memoId => $memo) {
        if (isset($categories[$memo['category']])) {
            $result = $storage->modify($memoId, $memo['desc'], $memo['body'], $categories[$memo['category']]);
            if (is_a($result, 'PEAR_Error')) {
                Horde::fatal($result);
            }
        }
    }
}

echo "\n** Categories successfully converted ***\n";
exit;

function listCategories($notepad = null)
{
    global $prefs;

    static $catString, $categories;

    $cur = getPrefByShare('memo_categories', $notepad);
    if (is_null($catString) || $catString != $cur) {
        $categories = array(0 => _("Unfiled"));

        $catString = $cur;
        if (empty($catString)) {
            return $categories;
        }

        $cats = explode('|', $catString);
        foreach ($cats as $cat) {
            list($key, $val) = explode(':', $cat);
            $categories[$key] = $val;
        }
    }

    asort($categories);
    return $categories;
}

function getPrefByShare($pref, $share = null)
{
    if (!is_a($share, 'DataTreeObject_Share')) {
        $share = $GLOBALS['mnemo_shares']->getShare($share);
        if (is_a($share, 'PEAR_Error')) {
            return null;
        }
    }

    $owner = $share->get('owner');
    $userprefs = &Prefs::singleton($GLOBALS['conf']['prefs']['driver'],
                                   $GLOBALS['registry']->getApp(),
                                   $owner, '', null, false);
    $userprefs->retrieve();
    return $userprefs->getValue($pref);
}
